package io.gitlab.jfronny.yescheat.mixin;

import io.gitlab.jfronny.yescheat.YesCheat;
import net.minecraft.server.network.ServerPlayNetworkHandler;
import net.minecraft.text.Text;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Redirect;

@Mixin(ServerPlayNetworkHandler.class)
public abstract class ServerPlayNetworkHandlerMixin {
    @Redirect(method = "tick()V", at = @At(value = "INVOKE", target = "Lnet/minecraft/server/network/ServerPlayNetworkHandler;disconnect(Lnet/minecraft/text/Text;)V"))
    private void overwriteFloatingCheck(ServerPlayNetworkHandler handler, Text reason) {
        YesCheat.LOGGER.info("Cancelled disconnect: " + reason.asString());
    }

    @Redirect(method = "onVehicleMove(Lnet/minecraft/network/packet/c2s/play/VehicleMoveC2SPacket;)V", at = @At(value = "INVOKE", target = "Lnet/minecraft/server/network/ServerPlayNetworkHandler;isHost()Z"))
    private boolean overwriteVehicleCheck(ServerPlayNetworkHandler p) {
        return true;
    }

    @Redirect(method = "onPlayerMove(Lnet/minecraft/network/packet/c2s/play/PlayerMoveC2SPacket;)V", at = @At(value = "INVOKE", target = "Lnet/minecraft/server/network/ServerPlayNetworkHandler;isHost()Z"))
    private boolean overwritePlayerMoveSpeedCheck(ServerPlayNetworkHandler p) {
        return true;
    }
}
